
/**
   Copyright 2019, Max Regan

   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:

   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
   LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
   OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
   WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
**/

#ifndef _MACROS_H_
#define _MACROS_H_

#include <assert.h>

/**
 * I'll probably regret writing all of these at some point.
 */

#define ARRAY_SIZE(x) (sizeof(x) / sizeof(x[0]))

#define MIN(a,b) ((a > b) ? (b) : (a))
#define MAX(a,b) ((a < b) ? (b) : (a))

/*
 * For usage with STM32 libraries
 */

#define STM32_GET_FIELD(x, name)                \
    ((x) & name##_Msk) >> (name##_Pos)

/*
 * Bitwise Operations
 */

#define SET(x, y)                               \
    do {                                        \
        (x) |= (y);                             \
    } while (0)

#define SET_POS(x, y)                           \
    do {                                        \
        (x) |= 1u << (y);                       \
    } while (0)

#define CLR(x, y)                             \
    do {                                        \
        (x) &= ~(y);                            \
    } while (0)

#define CLR_POS(x, y)                         \
    do {                                        \
        (x) &= ~(1u << (y));                    \
    } while (0)

#define FLIP(x, y)                              \
    do {                                        \
        (x) ^= (y);                             \
    } while (0)

#define FLIP_POS(x, y)                          \
    do {                                        \
        (x) ^= 1u << y;                         \
    } while (0)

#define SET_TO(x, clear_mask, val)                                      \
    do {                                                                \
        CLR(x, clear_mask);                                           \
        SET(x, val);                                                    \
    } while (0)

#endif
